/*************************************************************************
*	"crc16cc.c"
*-------------------------------------------------------------------------
*	$Id: crc16cc.c 94 2006-09-20 08:51:21Z taro $
*************************************************************************/

#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif
#include	"crc16.h"
#include	<stdlib.h>
#include	<limits.h>

#define	CC_CRCPOLY	0x8408u		/* Et] */

static int		crc16cc_table_init = 0;
unsigned int	crc16cc_table[UCHAR_MAX + 1];

#ifndef	BYTE
#	define	BYTE	unsigned char
#endif

static void	crc16cc_maketable(void)
{
	unsigned int i, j, r;

	for (i = 0; i <= UCHAR_MAX; i++)
	{
		r = i;
		for (j = 0; j < CHAR_BIT; j++)
			if (r & 1)
				r = (r >> 1) ^ CC_CRCPOLY;
			else
				r >>= 1;
		crc16cc_table[i] = r;
	}
	return;
}

void		crc16cc_init(Crc16work * crcwork)
{
	if ( crcwork == NULL )
		return;
	if ( crc16cc_table_init == 0 )
	{
		crc16cc_maketable();
		crc16cc_table_init = 1;
	}
	crcwork->r = 0xFFFFu;
	return;
}

void	crc16cc_calc(Crc16work * crcwork, int n, const void * p)
{
	const BYTE	*c = (const BYTE *)p;

	while (--n >= 0 )
		crcwork->r = ((crcwork->r) >> CHAR_BIT) ^ crc16cc_table[(BYTE)(crcwork->r) ^ *c++];
}

crc16_t	crc16cc_getcrc(Crc16work * crcwork)
{
	return (crcwork->r) ^ 0xFFFFu;
}

void		crc16cc_term(Crc16work * crcwork)
{
	return;
}



