//////////////////////////////////////////////////////////////////////////
//	"devctl_scsi.cpp"
//------------------------------------------------------------------------
//	$Id: devctl_scsi.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#ifdef	HAVE_CONFIG_H
#	include	"../config.h"
#	undef	HAVE_CONFIG_H
#endif
#include	"devctl.h"
#if	defined(HAVE_LINUX_HDREG_H)
#	include	"linux/hdreg.h"
#endif

//////////////////////////////////////////////////////////////////////////
//	 ScsiInqData

DevCtl::ScsiInqData::ScsiInqData()
{
	this->pathId     = 0;
	this->targetId   = 0;
	this->lun        = 0;
	this->devClaimed = FALSE;
	this->size       = 0;
	this->data       = NULL;
	this->unknownId  = FALSE;
}

DevCtl::ScsiInqData::~ScsiInqData()
{
	if ( this->data != NULL )
	{
		delete [] this->data;
		this->data = NULL;
	}
}

int		DevCtl::ScsiCreateInqData(DevCtl::ScsiInqData & inqData, int pathId, int targetId, int lun)
{
	SCSIINQUIRY	inq;

	memset(&inq, 0, sizeof(inq));
	switch ( this->htype )
	{
		case HT_SG:
			if ( this->ScsiInquiry(pathId, targetId, lun, -1, sizeof(inq), &inq) < 0 )
				return -1;
			break;
		case HT_BLKDEV:
		case HT_CDROM:
			if ( this->BlkDeviInquiry(inq) < 0 )
				return -1;
			break;
	}
	inqData.pathId     = pathId;
	inqData.targetId   = targetId;
	inqData.lun        = pathId;
	inqData.devClaimed = FALSE;
	inqData.size       = sizeof(inq);
	if ( inqData.data != NULL )
		delete [] inqData.data;
	if ( (inqData.data = new BYTE [sizeof(inq)]) == NULL )
		return -1;
	memcpy(inqData.data, &inq, sizeof(inq));

	return 0;
}

//////////////////////////////////////////////////////////////////////////
//	SCSI

// Check SCSI Condition (sense buffer)
int		DevCtl::ScsiCheckCondition(DevCtl::Sgt & sgt)
{
	if ( sgt.sense[7] < 10 )
		return 0;	// error
	return sgt.sense[12] == 0x23 || sgt.sense[12] == 0x28 ? 1 : 0;
}

