//////////////////////////////////////////////////////////////////////////
//	"sc_readcapacity.cpp"
//------------------------------------------------------------------------
//	$Id: sc_readcapacity.cpp 96 2006-09-20 09:34:10Z taro $
//////////////////////////////////////////////////////////////////////////

#ifdef	HAVE_CONFIG_H
#	include	"../config.h"
#	undef	HAVE_CONFIG_H
#endif
#include	"devctl.h"

int		DevCtl::ScsiReadCapacity(int pathId, int targetId, int lun, unsigned size, void * buffer)
{
	Sgt		sgt;

	if ( this->fd < 0 )
		return -1;
	if ( (this->htype == HT_BLKDEV || this->htype == HT_CDROM || this->htype == HT_FILE)
	  && size >= sizeof(SCSICAPACITYDATA) )
	{
		if ( this->maxCdbSize < SCSI_CDB16_LEN || size < sizeof(SCSICAPACITYDATA16) )
		{	// 12
			SCSICAPACITYDATA	*capa;

			capa = (SCSICAPACITYDATA *)buffer;
			DevCtl::ScsiSetLBA(capa->logicalBlockAddress, this->blk.blkNum);
			DevCtl::ScsiSetLBA(capa->blockLength        , this->blk.blkLen);
		} else
		{	// 16
			SCSICAPACITYDATA16	*capa;

			capa = (SCSICAPACITYDATA16 *)buffer;
			SCSI_PUT64(capa->logicalBlockAddress, this->blk.blkNum);
			SCSI_PUT32(capa->blockLength        , this->blk.blkLen);
		}
		return 0;
	}
	if ( this->htype != HT_SG )
		return -1;
	for (;;)
	{
		memset(&sgt, 0, sizeof(sgt));
		if ( this->maxCdbSize < SCSI_CDB16_LEN || size < sizeof(SCSICAPACITYDATA16) )
		{
			sgt.fd                  = this->fd;
			sgt.hdr.interface_id    = 'S';
			sgt.hdr.dxfer_direction = SG_DXFER_FROM_DEV;
			sgt.hdr.cmd_len         = SCSI_CDB10_LEN;
		//	sgt.hdr.iovec_count     = 0;
			sgt.hdr.mx_sb_len       = SCSI_SENSE_LEN;
			sgt.hdr.dxfer_len       = size;
			sgt.hdr.dxferp          = buffer;
			sgt.hdr.cmdp            = sgt.cdb;
			sgt.hdr.sbp             = sgt.sense;
			sgt.hdr.timeout         = this->scsi_timeout;
		//	sgt.hdr.flags           = 0;
		//	sgt.hdr.pack_id         = 0;
		//	sgt.hdr.usr_ptr         = NULL;
			sgt.cdb[0]              = 0x25; // Read Capacity
			sgt.cdb[1]              = lun << 5;
		//	sgt.cdb[2]              = 0;
		//	sgt.cdb[3]              = 0;
		//	sgt.cdb[4]              = 0;
		//	sgt.cdb[5]              = 0;
		//	sgt.cdb[6]              = 0;
		//	sgt.cdb[7]              = 0;
		//	sgt.cdb[8]              = 0;	// 0x01 == Num of Sec
		//	sgt.cdb[9]              = 0;
		} else
		{
			sgt.fd                  = this->fd;
			sgt.hdr.interface_id    = 'S';
			sgt.hdr.dxfer_direction = SG_DXFER_FROM_DEV;
			sgt.hdr.cmd_len         = SCSI_CDB16_LEN;
		//	sgt.hdr.iovec_count     = 0;
			sgt.hdr.mx_sb_len       = SCSI_SENSE_LEN;
			sgt.hdr.dxfer_len       = size;
			sgt.hdr.dxferp          = buffer;
			sgt.hdr.cmdp            = sgt.cdb;
			sgt.hdr.sbp             = sgt.sense;
			sgt.hdr.timeout         = this->scsi_timeout;
		//	sgt.hdr.flags           = 0;
		//	sgt.hdr.pack_id         = 0;
		//	sgt.hdr.usr_ptr         = NULL;
			sgt.cdb[ 0]             = DevCtl::SCSI_OP_SERVICE_ACTION_IN; 	// READ CAPACITY (16) : SERVICE ACTION IN
			sgt.cdb[ 1]             = (lun << 5) | DevCtl::SCSI_SERVICE_ACTION_READ_CAPACITY16;	// SERVICE ACTION
		//	sgt.cdb[ 2]             = 0;
		//	sgt.cdb[ 3]             = 0;
		//	sgt.cdb[ 4]             = 0;
		//	sgt.cdb[ 5]             = 0;
		//	sgt.cdb[ 6]             = 0;
		//	sgt.cdb[ 7]             = 0;
		//	sgt.cdb[ 8]             = 0;	// 0x01 == Num of Sec
		//	sgt.cdb[ 9]             = 0;
			sgt.cdb[10]             =  (BYTE)((size >> 24) & 0xFF);
			sgt.cdb[11]             =  (BYTE)((size >> 16) & 0xFF);
			sgt.cdb[12]             =  (BYTE)((size >>  8) & 0xFF);
			sgt.cdb[13]             =  (BYTE)( size        & 0xFF);
		//	sgt.cdb[14]             = 0;	// 0x01 == Num of Sec (Pertial medium indicator)
		//	sgt.cdb[15]             = 0;
		}
		if ( ioctl(sgt.fd, SG_IO, &sgt.hdr) < 0 )
			return -1; // error
		if ( (sgt.hdr.info & SG_INFO_OK_MASK) != SG_INFO_OK )
		{
			if ( sgt.hdr.sb_len_wr > 0 && this->ScsiCheckCondition(sgt) > 0 )
				continue;	// retry
			return -1;
		} else
		{
			if ( this->scsiCapacityMode == DevCtl::SCSI_CAPACITYMODE_COUNT )
			{
				INT64	n;

				if ( this->maxCdbSize < SCSI_CDB16_LEN || size < sizeof(SCSICAPACITYDATA16) )
				{
					n = this->ScsiGetLBA((BYTE *)buffer) + I64(1);
					this->ScsiSetLBA((BYTE *)buffer, n);
				} else
				{
					n = SCSI_GET64((BYTE *)buffer) + I64(1);
					SCSI_PUT64((BYTE *)buffer, n);
				}
			}
			return sgt.hdr.resid;	// OK
		}
	}
}
