/*************************************************************************
*	"md4ram.h"
*-------------------------------------------------------------------------
*	$Id: md4ram.h 94 2006-09-20 08:51:21Z taro $
*************************************************************************/
#ifndef	MD4RAM_H_INCLUDED
#define	MD4RAM_H_INCLUDED

#define	MD4R_DRIVER_NAME			"MD4RAM"
#define	MD4R_VERSION_NUMBER			"1.03a"
#define	MD4R_EDITION_NUMBER			"01"
#define	MD4R_SCSI_VENDER_ID			"MD4RAM  "
#define	MD4R_SCSI_PRODUCT_VERSION	"103A"

#define	MD4R_PARAM_ID				{'M','D','4','R','A','M',' ',' '}
#define	MD4R_VERSION_ID				{'1','.','0','3','A','#','0','1'}
#define	MD4R_PARAM_ID_LENGTH		(8)
#define	MD4R_VERSION_ID_LENGTH		(8)

#define	MD4R_ARRAY_MAX				(16)
#define	MD4R_DEVICE_MAX				(16)
#define	MD4R_MAX_NAME_LENGTH		(256)
#define	MD4R_MAX_RAM_SIZE			(0x80000000)	// 2G
#define	MD4R_MAX_BITSTABLE_SIZE		(0x20000000)	// 512M for MapCache
#define	MD4R_DEFAULT_TRANSFER_SIZE	(0x20000)	// 128K
#define	MD4R_SIGN_LENGTH			(8)
#define	MD4R_SIGN_ARRAYNAME_LENGTH	(32)
#define	MD4R_CRYPTO_HASH_LENGTH		(32)
#define	MD4R_CRYPTO_SERIAL_LENGTH	(32)
#define	MD4R_DEFAULT_LOG_SIZE		(1*1024*1024)	// 1M

#ifndef	MD4R_T
# ifdef _NTDDK_
#  define MD4R_TEXT(x)	L ## x
# else
#  define MD4R_TEXT(x)	x
# endif
#endif

#define MD4R_DEVICE_BASE_NAME				MD4R_TEXT("\\MD4Ram")
#define MD4R_DEVICE_DIR_NAME				MD4R_TEXT("\\Device") MD4R_DEVICE_BASE_NAME
#define MD4R_DISK_DEVICE_PREFIX_NAME		MD4R_DEVICE_DIR_NAME  MD4R_DEVICE_BASE_NAME MD4R_TEXT("Disk")
#define MD4R_CDROM_DEVICE_PREFIX_NAME		MD4R_DEVICE_DIR_NAME  MD4R_DEVICE_BASE_NAME MD4R_TEXT("Cd")

#define MD4RAM_ARRAY_DEVICE			0x8000
#define IOCTL_MD4RAM_OPEN_ARRAY		CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x800, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_MD4RAM_CLOSE_ARRAY	CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x801, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_MD4RAM_QUERY_ARRAY	CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x802, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_MD4RAM_SET_CRYPTOKEY	CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x803, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_MD4RAM_SET_MAPCACHE	CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x804, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_MD4RAM_GET_MAPCACHE	CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x805, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_MD4RAM_SET_LOG		CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x806, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_MD4RAM_GET_LOG		CTL_CODE(MD4RAM_ARRAY_DEVICE, 0x807, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

#ifndef	MD4R_INT64_DEFINED
# define	MD4R_INT64_DEFINED
  typedef __int64		MD4R_INT64;
#endif
#ifndef	MD4R_UINT64_DEFINED
# define	MD4R_UINT64_DEFINED
 typedef unsigned __int64	MD4R_UINT64;
#endif

#define	MD4R_GET64(p)	(((MD4R_UINT64)((UCHAR *)(p))[0]<<56)+((MD4R_UINT64)((UCHAR *)(p))[1]<<48)+((MD4R_UINT64)((UCHAR *)(p))[2]<<40)+((MD4R_UINT64)((UCHAR *)(p))[3]<<32)+((MD4R_UINT64)((UCHAR *)(p))[4]<<24)+((MD4R_UINT64)((UCHAR *)(p))[5]<<16)+((MD4R_UINT64)((UCHAR *)(p))[6]<<8)+((MD4R_UINT64)((UCHAR *)(p))[7]))
#define	MD4R_GET48(p)	(((MD4R_UINT64)((UCHAR *)(p))[0]<<40)+((MD4R_UINT64)((UCHAR *)(p))[1]<<32)+((MD4R_UINT64)((UCHAR *)(p))[2]<<24)+((MD4R_UINT64)((UCHAR *)(p))[3]<<16)+((MD4R_UINT64)((UCHAR *)(p))[4]<<8)+((MD4R_UINT64)((UCHAR *)(p))[5]))
#define	MD4R_GET32(p)	(((ULONG)((UCHAR *)(p))[0]<<24)+((ULONG)((UCHAR *)(p))[1]<<16)+((ULONG)((UCHAR *)(p))[2]<<8)+((ULONG)((UCHAR *)(p))[3]))
#define	MD4R_GET24(p)	(((ULONG)((UCHAR *)(p))[0]<<16)+((ULONG)((UCHAR *)(p))[1]<<8)+((ULONG)((UCHAR *)(p))[2]))
#define	MD4R_GET16(p)	((USHORT)(((UCHAR *)(p))[0]<<8)+((USHORT)((UCHAR *)(p))[1]))
#define	MD4R_GET8(p)	(((UCHAR *)(p))[0])

#define	MD4R_PUT64(p,u)	{ ((UCHAR *)(p))[0]=(UCHAR)((u)>>56); ((UCHAR *)(p))[1]=(UCHAR)((u)>>48); ((UCHAR *)(p))[2]=(UCHAR)((u)>>40); ((UCHAR *)(p))[3]=(UCHAR)((u)>>32); ((UCHAR *)(p))[4]=(UCHAR)((u)>>24); ((UCHAR *)(p))[5]=(UCHAR)((u)>>16); ((UCHAR *)(p))[6]=(UCHAR)((u)>>8); ((UCHAR *)(p))[7]=(UCHAR)(u); }
#define	MD4R_PUT48(p,u)	{ ((UCHAR *)(p))[0]=(UCHAR)((u)>>40); ((UCHAR *)(p))[1]=(UCHAR)((u)>>32); ((UCHAR *)(p))[2]=(UCHAR)((u)>>24); ((UCHAR *)(p))[3]=(UCHAR)((u)>>16); ((UCHAR *)(p))[4]=(UCHAR)((u)>>8); ((UCHAR *)(p))[5]=(UCHAR)(u); }
#define	MD4R_PUT32(p,u)	{ ((UCHAR *)(p))[0]=(UCHAR)((u)>>24); ((UCHAR *)(p))[1]=(UCHAR)((u)>>16); ((UCHAR *)(p))[2]=(UCHAR)((u)>>8); ((UCHAR *)(p))[3]=(UCHAR)(u); }
#define	MD4R_PUT24(p,u)	{ ((UCHAR *)(p))[0]=(UCHAR)((u)>>16); ((UCHAR *)(p))[1]=(UCHAR)((u)>>8); ((UCHAR *)(p))[2]=(UCHAR)(u); }
#define	MD4R_PUT16(p,u)	{ ((UCHAR *)(p))[0]=(UCHAR)((u)>>8); ((UCHAR *)(p))[1]=(UCHAR)(u); }
#define	MD4R_PUT8(p,u)	{ ((UCHAR *)(p))[0]=(UCHAR)(u); }

enum MD4R_Array_Type
{
	MD4R_ARRAY_UNKNOWN  ,
	MD4R_ARRAY_DISK     ,
	MD4R_ARRAY_CDROM    ,
};

enum MD4R_Array_Mode
{
	MD4R_MODE_UNKNOWN,
	MD4R_MODE_LINEAR ,
	MD4R_MODE_STRIPE ,
	MD4R_MODE_MIRROR ,
};

enum MD4R_DevType
{
	MD4R_DEVTYPE_ERROR   = -1,
	MD4R_DEVTYPE_UNKNOWN = 0,
	MD4R_DEVTYPE_DISK   ,
	MD4R_DEVTYPE_DRIVE  ,
	MD4R_DEVTYPE_FILE   ,
	MD4R_DEVTYPE_RAM    ,
	MD4R_DEVTYPE_NET    ,
};

enum	MD4R_RamType
{
	MD4R_RAMTYPE_NONPAGEDPOOL,
	MD4R_RAMTYPE_PAGEDPOOL   ,
//	MD4R_RAMTYPE_EX          ,
};
#define	MD4R_GET_RAMTYPE(devParam_)			(((devParam_)->shread<<1) | ((devParam_)->shwrite))
#define	MD4R_SET_RAMTYPE(devParam_, type_)	{ (devParam_)->shread = ((type_)>>1) & 1;  (devParam_)->shwrite = (type_) & 1; }

enum	MD4R_SignType
{
	MD4R_SIGN_NOTHING,
	MD4R_SIGN_BEGIN  ,	// Location >= 0
	MD4R_SIGN_END    ,	// Location <= -1
};

#if	defined(_MSC_VER)
#	pragma pack(push,1)
#endif

typedef	union MD4R_TimeParam_tag
{
	MD4R_UINT64			n;
	struct md4r_time_param
	{
		UCHAR			year[2];
		unsigned char	month : 6;
		unsigned char	day   : 5;
		unsigned char	hour  : 5;
		UCHAR			minute;
		UCHAR			second;
		UCHAR			msec[2];
	} s;
} MD4R_TimeParam;

typedef	struct MD4R_ArrayDevParam_tag
{
	UCHAR			devtype;
	unsigned char	primary   : 1;	// use MIRROR
	unsigned char	dataSync  : 1;	// use MIRROR (not use
	unsigned char	rsv1      : 1;
	unsigned char	crypto    : 1;
	unsigned char	shwrite   : 1;	// or RAM Device Mode
	unsigned char	shread    : 1;	// or RAM Device Mode
	unsigned char	buffered  : 1;
	unsigned char	writable  : 1;
	UCHAR			blockSize[4];
	UCHAR			blockAddr[6];
	UCHAR			blockNumber[6];
	UCHAR			signType;
	UCHAR			sign_rsv;
	UCHAR			signLocation[6];
	UCHAR			port[2];
	UCHAR			netrsv;
	UCHAR			pathId;
	UCHAR			targetId;
	UCHAR			lun;
	UCHAR			ipaddr[4];
	UCHAR			nameLength[2];
	UCHAR			name[MD4R_MAX_NAME_LENGTH];
} MD4R_ArrayDevParam;

typedef struct MD4R_ArrayParam_tag
{
	UCHAR				id[MD4R_PARAM_ID_LENGTH];
	UCHAR				version[MD4R_VERSION_ID_LENGTH];
	UCHAR				type;
	UCHAR				mode;
	UCHAR				rsv1;
	unsigned char		removable   : 1;
	unsigned char		rsv2        : 2;
	unsigned char		crypto      : 1;
	unsigned char		rsv_shwrite : 1;
	unsigned char		rsv_shread  : 1;
	unsigned char		rsv_buffered: 1;
	unsigned char		readonly    : 1;
	UCHAR				blockSize[4];
	UCHAR				blockNumber[6];
	UCHAR				chunkBlkNum[2];
	UCHAR				transferSize[4];
	MD4R_TimeParam		startTime;
	UCHAR				partitionType;	// not use
	UCHAR				devNum;
	MD4R_ArrayDevParam	dev[1];
} MD4R_ArrayParam;

#define	MD4R_MAX_CRYPTOKEY_BITS			(1024)
#define	MD4R_CRYPTO_METHOD_ID_LENGTH	(8)
#define	MD4R_CRYPTO_METHOD_ID_BLOWFISH	{'-','B','L','F','4','4','8','-'}
#define	MD4R_CRYPTO_METHOD_ID_AES256 	{'-','A','E','S','2','5','6','-'}

enum	MD4R_CryptoMethod
{
	MD4R_CRYPTO_METHOD_ERROR = -1,
	MD4R_CRYPTO_METHOD_OFF   =  0,
	MD4R_CRYPTO_METHOD_BLOWFISH,
	MD4R_CRYPTO_METHOD_AES256  ,
};
enum	MD4R_CryptoSetType
{
	MD4R_CRYPTO_SET_TYPE_ARRAY ,
	MD4R_CRYPTO_SET_TYPE_DEVICE,
};

enum	MD4R_CryptoHashType
{
	MD4R_CRYPTO_HASHTYPE_NONE    ,
	MD4R_CRYPTO_HASHTYPE_PASSWORD,
	MD4R_CRYPTO_HASHTYPE_KEYDATA ,
};

typedef struct MD4R_CyrptoKeyParam_tag
{
	UCHAR			id[MD4R_PARAM_ID_LENGTH];
	UCHAR			version[MD4R_VERSION_ID_LENGTH];
	UCHAR			type;
	UCHAR			devno;
	UCHAR			method_id[MD4R_CRYPTO_METHOD_ID_LENGTH];
	UCHAR			keyBits[2];
	UCHAR			key[1];
} MD4R_CryptoKeyParam;

#define	MD4R_CRYPTO_KEY_PARAMSIZE(keybits_)	((int)sizeof(MD4R_CryptoKeyParam) + (int)sizeof(UCHAR) * ((((keybits_)+7)/8)-1))

typedef struct MD4R_SignBlock_tag
{
	UCHAR					id[MD4R_PARAM_ID_LENGTH];
	UCHAR					version[MD4R_VERSION_ID_LENGTH];
	UCHAR					sign[MD4R_SIGN_LENGTH];
	struct md4r_signblock_array
	{
		UCHAR				type;
		UCHAR				mode;
		struct md4r_signblock_array_att
		{
			unsigned char	useCryptoSign: 1;
			UCHAR			rsv1         : 7;
			unsigned char	removable    : 1;
			unsigned char	rsv2         : 2;
			unsigned char	crypto       : 1;
			unsigned char	rsv_shwrite  : 1;
			unsigned char	rsv_shread   : 1;
			unsigned char	rsv_buffered : 1;
			unsigned char	readonly     : 1;
		} att;
		UCHAR				blockSize[4];
		UCHAR				blockNumber[6];
		UCHAR				chunkBlkNum[2];
		UCHAR				array_rsb;
		UCHAR				devNum;
		UCHAR				cryptoMethodId[MD4R_CRYPTO_METHOD_ID_LENGTH];
		UCHAR				cryptoHashType;
		UCHAR				cryptoHashLength;
		UCHAR				cryptoHash[MD4R_CRYPTO_HASH_LENGTH];
	} array;
	struct md4r_signblock_device
	{
		UCHAR				devtype;
		UCHAR				devno;
		struct md4r_signblock_device_att
		{
			UCHAR			rsv_byte;
			unsigned char	rsv_primary  : 1;
			unsigned char	rsv_dataSync : 1;
			unsigned char	rsv1         : 1;
			unsigned char	crypto       : 1;
			unsigned char	rsv_shwrite  : 1;
			unsigned char	rsv_shread   : 1;
			unsigned char	rsv_buffered : 1;
			unsigned char	rsv_writable : 1;
		} att;
		UCHAR				blockSize[4];
		UCHAR				blockAddr[6];
		UCHAR				blockNumber[6];
		UCHAR				cryptoMethodId[MD4R_CRYPTO_METHOD_ID_LENGTH];
		UCHAR				cryptoHashType;
		UCHAR				cryptoHashLength;
		UCHAR				cryptoHash[MD4R_CRYPTO_HASH_LENGTH];
	} dev;
	MD4R_TimeParam			startTime;
	MD4R_TimeParam			stopTime;
	UCHAR					mountCount[4];
	UCHAR					arrayName[MD4R_SIGN_ARRAYNAME_LENGTH];
} MD4R_SignBlock;

typedef struct MD4R_SignBlock101A01_tag
{
	UCHAR					id[MD4R_PARAM_ID_LENGTH];
	UCHAR					version[MD4R_VERSION_ID_LENGTH];
	UCHAR					sign[MD4R_SIGN_LENGTH];
	struct md4r_signblock101A01_array
	{
		UCHAR				type;
		UCHAR				mode;
		struct md4r_signblock101A01_array_att
		{
			UCHAR			rsv_byte;
			unsigned char	removable   : 1;
			unsigned char	rsv2        : 2;
			unsigned char	crypto      : 1;
			unsigned char	rsv_shwrite : 1;
			unsigned char	rsv_shread  : 1;
			unsigned char	rsv_buffered: 1;
			unsigned char	readonly    : 1;
		} att;
		UCHAR				blockSize[4];
		UCHAR				blockNumber[6];
		UCHAR				chunkBlkNum[2];
		UCHAR				array_rsb;
		UCHAR				devNum;
		UCHAR				cryptoMethodId[MD4R_CRYPTO_METHOD_ID_LENGTH];
	} array;
	struct md4r_signblock101A01_device
	{
		UCHAR				devtype;
		UCHAR				devno;
		struct md4r_signblock101A01_device_att
		{
			UCHAR			rsv_byte;
			unsigned char	rsv_primary : 1;
			unsigned char	rsv_dataSync: 1;
			unsigned char	rsv1        : 1;
			unsigned char	crypto      : 1;
			unsigned char	rsv_shwrite : 1;
			unsigned char	rsv_shread  : 1;
			unsigned char	rsv_buffered: 1;
			unsigned char	rsv_writable: 1;
		} att;
		UCHAR				blockSize[4];
		UCHAR				blockAddr[6];
		UCHAR				blockNumber[6];
		UCHAR				cryptoMethodId[MD4R_CRYPTO_METHOD_ID_LENGTH];
	} dev;
	MD4R_TimeParam			startTime;
	MD4R_TimeParam			stopTime;
	UCHAR					mountCount[4];
	UCHAR					arrayName[MD4R_SIGN_ARRAYNAME_LENGTH];
} MD4R_SignBlock101A01;

enum	MD4R_Map_Mode
{
	MD4R_MAP_MODE_OFF  ,
	MD4R_MAP_MODE_TABLE,	// table mode
	MD4R_MAP_MODE_LIST ,	// list mode
};

#define	MD4R_MAP_FLUSH_LEVEL_NUM	(3)

typedef struct MD4R_MapCacheParam_tag
{
	UCHAR				id[MD4R_PARAM_ID_LENGTH];
	UCHAR				version[MD4R_VERSION_ID_LENGTH];
	UCHAR				mapMode;
	UCHAR				devType;
	UCHAR				rsv;
	unsigned char		rsv_0_4     : 4;
	unsigned char		shwrite     : 1;	// RAM Type Mode
	unsigned char		shread      : 1;	// RAM Type Mode
	unsigned			flushRequest: 1;
	unsigned char		writeback   : 1;
	UCHAR				blockAddr[6];
	UCHAR				blockNumber[6];
	UCHAR				blockSize[4];
	UCHAR				nameLength[2];
	UCHAR				name[MD4R_MAX_NAME_LENGTH];
	struct md4r_mapcache_conf_tag
	{
		UCHAR			maxSpoolBlocks[6];
		UCHAR			minSpoolBlocks[6];
		UCHAR			flushWriteBlocks[6];
		UCHAR			flushPassTime[4];
		UCHAR			flushTimeLimit[4];
		UCHAR			maxFlushBlocks[6];
		UCHAR			minFlushBlocks[6];
		UCHAR			arrayFlushRange[6];
	} conf[MD4R_MAP_FLUSH_LEVEL_NUM];
	struct md4r_mapcache_stat_tag
	{
		UCHAR			free_blocks[6];
		UCHAR			allocate_blocks[6];
		UCHAR			total_read_blocks[6];
		UCHAR			total_read_count[6];
		UCHAR			total_write_blocks[6];
		UCHAR			total_write_count[6];
		UCHAR			read_hit_blocks[6];
		UCHAR			read_hit_count[6];
		UCHAR			read_error_blocks[6];
		UCHAR			read_error_count[6];
		UCHAR			write_error_blocks[6];
		UCHAR			write_error_count[6];
		UCHAR			logical_total_seek[6];
		UCHAR			physical_total_seek[6];
		UCHAR			write_back_blocks[6];
		UCHAR			write_back_count[6];
		UCHAR			flush_write_blocks[6];
		UCHAR			flush_write_count[6];
		UCHAR			flush_error_blocks[6];
		UCHAR			flush_error_count[6];
		UCHAR			unsync_blocks[6];
		UCHAR			overlap_sync_blocks[6];
		UCHAR			max_flush_count[4];
		UCHAR			std_flush_count[4];
		UCHAR			min_flush_count[4];
		UCHAR			item_flush_count[4];
		UCHAR			flush_abort_count[4];
	} stat;
} MD4R_MapCacheParam;


#define	MD4R_ARRAYPARAM_SIZE(devnum_)	((int)sizeof(MD4R_ArrayParam) + ((int)(devnum_)-1) * (int)sizeof(MD4R_ArrayDevParam))

typedef struct MD4R_LogParam_tag
{
	UCHAR			id[MD4R_PARAM_ID_LENGTH];
	UCHAR			version[MD4R_VERSION_ID_LENGTH];
	UCHAR			size[4];
	UCHAR			log[1];
} MD4R_LogParam;

//#define	MD4R_LOG_PARAMSIZE(size_)	((int)sizeof(MD4R_LogParam) + (int)sizeof(UCHAR) * ((size_) - 1))

enum	MD4R_LogItemType
{
	MD4R_LOGITEM_TYPE_NOTHING     ,
	MD4R_LOGITEM_TYPE_TEXT        ,

	MD4R_LOGITEM_TYPE_DEVIO_READ  ,
	MD4R_LOGITEM_TYPE_DEVIO_WRITE ,

	MD4R_LOGITEM_TYPE_ARRAY_READ  ,
	MD4R_LOGITEM_TYPE_ARRAY_WRITE ,

	MD4R_LOGITEM_TYPE_DEVICE_READ ,
	MD4R_LOGITEM_TYPE_DEVICE_WRITE,

	MD4R_LOGITEM_TYPE_CACHE_READ  ,
	MD4R_LOGITEM_TYPE_CACHE_WRITE ,
};

typedef struct	MD4R_LogItem_tag
{
	UCHAR			size[2];
	UCHAR			type;
	UCHAR			no;
	UCHAR			tick[8];
	union
	{
		struct rw_tag
		{
			UCHAR			blockAddr[6];
			UCHAR			blockCount[6];
		} rw;
		struct cache_tag
		{
			UCHAR			cacheAddr[6];
			UCHAR			blockCount[6];
			UCHAR			arrayAddr[6];
		} cache;
		UCHAR		text[1];
	};
} MD4R_LogItem;

#if	defined(_MSC_VER)
#	pragma pack(pop)
#endif

#endif
