//////////////////////////////////////////////////////////////////////////
//	"sqstr_cmpi.cpp"
//------------------------------------------------------------------------
//	$Id: sqstr_cmpi.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif
#include	"sqstr.h"
#if	defined(WIN32)
#	include	<mbctype.h>
#endif
#include	<limits.h>

int		SQStr::StrCmpi(const TCHAR *s1, const TCHAR * s2, unsigned n)
{
	int			ret;
	unsigned	len;

	if ( s1 == NULL && s2 != NULL )
		return -1;
	if ( s1 != NULL && s2 == NULL )
		return 1;
	if ( s1 == s2 )
		return 0;
	len = 0;
	ret = 0;
#if	SQCHCODE_DEFAULT==SQCHCODE_SJIS
	{
		int		ch1, ch2;

		while ( len < n )
		{
			ch1 = *(unsigned char *)s1; s1++; len++;
			if ( _ismbblead(ch1) && _ismbbtrail(*(unsigned char*)s1) )
			{
				ch1 = (ch1<<8) | (*(unsigned char *)s1);
				s1++; len++;
			} else if ( ch1 >= 'a' && ch1 <= 'z' )
				ch1 = 'A' + (ch1 - 'a');

			ch2 = *(unsigned char *)s2; s2++;
			if ( _ismbblead(ch2) && _ismbbtrail(*(unsigned char*)s2) )
			{
				ch2 = (ch2<<8) | (*(unsigned char *)s2);
				s2++;
			} else if ( ch2 >= 'a' && ch2 <= 'z' )
				ch2 = 'A' + (ch2 - 'a');
			if ( (ret = ch1 - ch2) != 0 )
				break;
			if ( ch1 == 0 || ch2 == 0 )
				break;
		}
	}
#endif

#if SQCHCODE_DEFAULT==SQCHCODE_UNICODE
#error
#endif

	return ret;
}

int		SQStr::StrCmpi(const TCHAR *s1, const TCHAR * s2)
{
	return SQStr::StrCmpi(s1, s2, UINT_MAX);
}

