//////////////////////////////////////////////////////////////////////////
//	"varbuf.h" for md4rMan
//------------------------------------------------------------------------
//	$Id: varbuf.h 105 2006-09-20 21:36:16Z taro $
#ifndef	VARBUF_H_INCLUDED
#define	VARBUF_H_INCLUDED

#if	defined(WIN32)
# include	<windows.h>
# include	<tchar.h>
#elif defined(LINUX)
# include	"linux/defs.h"
# include	<string.h>
#endif
//#include	"iscrwbuf.h"

//////////////////////////////////////////////////////////////////////////
//	VarBuffer

class	VarBuffer			// oAuobt@
{
public:
	enum varbuffer_enum
	{
		LINE_BUFFER_SIZE = 512,
		RES_NOERROR = 0,
		RES_ERROR   = -1,
		RES_EOF     = -2,
		RES_FUNCERR = -3,
	};

public:
	unsigned	buffersize;
	unsigned	validsize;
	void	   *buffer;

	VarBuffer();
	virtual ~VarBuffer();
	void		Clear(void);
	int			Add(unsigned size, const void * data);
	int			AddChar(int ch);
	int			AddText(const TCHAR * text) { return this->Add((unsigned)_tcslen(text), text); }
	TCHAR *		GetText(void) const { return (TCHAR *)this->buffer; }
	unsigned	GetSize(void) const { return this->validsize; }
	unsigned	GetLength(void) { return this->validsize > 0 && ((TCHAR *)this->buffer)[this->validsize - 1] == TEXT('\0') ? this->validsize - 1 : this->validsize; }
	int			Printf(const TCHAR * form, ... );
	void		PutPos(int pos, ... );

public:
	const TCHAR	   *p;
	unsigned		len;
	unsigned		pos;
	unsigned		ln, cn;

	int			SetBuffer(void);
	int			SetBuffer(unsigned len, const TCHAR * text);
	int			IsEnd(void);
	int			GetChar(void);
	int			UnGetChar(int ch);
	int			SkipSpace(void);
	int			GetWord(VarBuffer & word);
	static int	IsSpace(int ch);
	static int	IsNameTopChar(int ch);
	static int	IsNameChar(int ch);
	int			GetString(VarBuffer & str, int term);
	int			GetLine(VarBuffer & str);
};

#endif
