//////////////////////////////////////////////////////////////////////////
//	"sc_logsense.cpp"
//------------------------------------------------------------------------
//	$Id: sc_logsense.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	"devctl.h"

int		DevCtl::ScsiLogSense(int pathId, int targetId, int lun, BOOL sp, BOOL ppc, unsigned pc, int pageCode, unsigned point, unsigned size, void * buffer)
{
	SPT_DIRECT_BUFFER	spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBuffer         = buffer;
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]         = 0x4D; // LOG SENSE
		spt.spt.Cdb[1]         = (lun << 5) + (sp ? 0x08:0) + (ppc ? 0x02:0);
		spt.spt.Cdb[2]         = ((pc&3)<<6) + (pageCode & 0x3F);
	//	spt.spt.Cdb[3]         = 0;
	//	spt.spt.Cdb[4]         = 0;
		spt.spt.Cdb[5]         = (BYTE)((point >> 8) & 0xFF);
		spt.spt.Cdb[6]         = (BYTE)( point       & 0xFF);
		spt.spt.Cdb[7]         = (BYTE)((size  >> 8) & 0xFF);
		spt.spt.Cdb[8]         = (BYTE)( size        & 0xFF);
	//	spt.spt.Cdb[9]         = 0;
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

