//////////////////////////////////////////////////////////////////////////
//	"sc_readtoc.cpp"
//------------------------------------------------------------------------
//	$Id: sc_readtoc.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	"devctl.h"

int		DevCtl::ScsiReadToc(int pathId, int targetId, int lun, BOOL msf, unsigned size, void * buffer)
{
	SPT_DIRECT_BUFFER	spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBuffer         = buffer;
		spt.spt.SenseInfoOffset    = offsetof(SPT_DIRECT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = DevCtl::SCSI_OP_READ_TOC; // 0x43 Read Toc
		spt.spt.Cdb[1]             = (lun << 5) + (msf ? 0x02 : 0);
	//	spt.spt.Cdb[2]             = 0;
	//	spt.spt.Cdb[3]             = 0;
	//	spt.spt.Cdb[4]             = 0;
	//	spt.spt.Cdb[5]             = 0;
	//	spt.spt.Cdb[6]             = 0;
		spt.spt.Cdb[7]             = (BYTE)((size >> 8) & 0xFF);
		spt.spt.Cdb[8]             = (BYTE)( size       & 0xFF);
	//	spt.spt.Cdb[9]             = 0;
		outsize = sizeof(spt);
	//	printf("check 3-1\n");
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH_DIRECT), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
	//	printf("check 3-2 ret=%d\n", ret);
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

int		DevCtl::ScsiReadToc(int pathId, int targetId, int lun, BOOL msf, DevCtl::SCSITOCDATA & toc)
{
	return this->ScsiReadToc(pathId, targetId, lun, msf, sizeof(toc), &toc);
}
