//////////////////////////////////////////////////////////////////////////
//	"sc_seek.cpp"
//------------------------------------------------------------------------
//	$Id: sc_seek.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	"devctl.h"

int		DevCtl::ScsiSeek(int pathId, int targetId, int lun, INT64 addr)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		if ( this->maxCdbSize < SCSI_CDB16_LEN )
		{
			memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
			spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
			spt.spt.PathId             = pathId;
			spt.spt.TargetId           = targetId;
			spt.spt.Lun                = lun;
			spt.spt.CdbLength          = SCSI_CDB10_LEN;
			spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
			spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
			spt.spt.DataTransferLength = 0;
			spt.spt.TimeOutValue       = this->scsi_timeout;
			spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
			spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
			spt.spt.Cdb[0]             = DevCtl::SCSI_OP_SEEK10; // Seek
			spt.spt.Cdb[1]             = lun << 5;
			spt.spt.Cdb[2]             = (BYTE)((addr >> 24) & 0xFF);
			spt.spt.Cdb[3]             = (BYTE)((addr >> 16) & 0xFF);
			spt.spt.Cdb[4]             = (BYTE)((addr >>  8) & 0xFF);
			spt.spt.Cdb[5]             = (BYTE)( addr        & 0xFF);
		//	spt.spt.Cdb[6]             = 0;
		//	spt.spt.Cdb[7]             = 0;
		//	spt.spt.Cdb[8]             = 0;
		//	spt.spt.Cdb[9]             = 0;
		} else
		{
			memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
			spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
			spt.spt.PathId             = pathId;
			spt.spt.TargetId           = targetId;
			spt.spt.Lun                = lun;
			spt.spt.CdbLength          = SCSI_CDB16_LEN;
			spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
			spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
			spt.spt.DataTransferLength = 0;
			spt.spt.TimeOutValue       = this->scsi_timeout;
			spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
			spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
			spt.spt.Cdb[ 0]            = DevCtl::SCSI_OP_SERVICE_ACTION_IN;	// READ LONG (16) : SERVICE ACTION IN
			spt.spt.Cdb[ 1]            = (lun << 5) | DevCtl::SCSI_SERVICE_ACTION_READ_LONG16;	// SERVICE ACTION 0x11
			spt.spt.Cdb[ 2]            = (BYTE)((addr >> 56) & 0xFF);
			spt.spt.Cdb[ 3]            = (BYTE)((addr >> 48) & 0xFF);
			spt.spt.Cdb[ 4]            = (BYTE)((addr >> 40) & 0xFF);
			spt.spt.Cdb[ 5]            = (BYTE)((addr >> 32) & 0xFF);
			spt.spt.Cdb[ 6]            = (BYTE)((addr >> 24) & 0xFF);
			spt.spt.Cdb[ 7]            = (BYTE)((addr >> 16) & 0xFF);
			spt.spt.Cdb[ 8]            = (BYTE)((addr >>  8) & 0xFF);
			spt.spt.Cdb[ 9]            = (BYTE)( addr        & 0xFF);
		//	spt.spt.Cdb[10]            = 0;
		//	spt.spt.Cdb[11]            = 0;
		//	spt.spt.Cdb[12]            = (BYTE)((bytes >>  8) & 0xFF);
		//	spt.spt.Cdb[13]            = (BYTE)( bytes        & 0xFF);
		//	spt.spt.Cdb[14]            = 0;
		//	spt.spt.Cdb[15]            = 0;
		}
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

